
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_ALGO
#define GR_SHQN_ALGO


#include "vertex.h"
#include "primitive.h"
#include "nbinding.h"
#include "normal.h"
#include "transform.h"
#include "box.h"

	/** @name Algorithms
	    @memo General pourpose algorithms
	 */
	//@{

	/// Automatic normal generator
void grGenNormal( const grVertex3f & vert, const grTriangles & prim, double cangle,
				  grNormalBinding & nbind, grNormalf & norm );
	/// Automatic 'best-view' generator
void grViewAll( const grVertex3f & vert, grScalef & scale, grTranslationf & trans );
	/// Automatic 'best-view' generator
void grViewAll( const Boxd & boundbox, grScalef & scale, grTranslationf & trans );
	/// Automatic 'best-view' generator
void grViewAll( const Boxf & boundbox, grScalef & scale, grTranslationf & trans );
	
	//@}

#endif