
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#ifndef GR_SHQN_MATRIX
#define GR_SHQN_MATRIX


	/** Matrix 4x4 template.
	    Not implemented in this version!
	 */
/*
template<class T> class grMatrix 
{
public:
    grMatrix & operator = ( const grMatrix & mat );
    
    grMatrix operator + ( const grMatrix & mat ) const;
    grMatrix operator - ( const grMatrix & mat ) const;
    grMatrix operator * ( const grMatrix & mat ) const;
    grMatrix operator - ( void ) const;
    grMatrix operator * ( const T k ) const;
	grMatrix operator / ( const T k ) const;
    
    grMatrix & operator += ( const grMatrix & m );
    grMatrix & operator -= ( const grMatrix & m );
    grMatrix & operator *= ( const grMatrix & m );
    grMatrix & operator *= ( const T k );
	grMatrix & operator /= ( const T k );
    
    grMatrix & Scalar( const T k );
    grMatrix & RotX ( const T alpha );
    grMatrix & RotY ( const T alpha );
    grMatrix & RotZ ( const T alpha );
    grMatrix & Trans( const T tx, const T ty, const T tz);    
    grMatrix & Scale( const T sx, const T sy, const T sz);
    grMatrix & Scale( const T k );
    
	grMatrix & Invert( void );

private:
	T m[4][4];
}
*/






























class grMatrix
{
public:
	enum MMODE {
		MODELVIEW	= GL_MODELVIEW,
		PROJECTION	= GL_PROJECTION,
		TEXTURE		= GL_TEXTURE
	};
	inline static void Push( void );
	inline static void Pop( void );
	inline static void LoadIdentity( void );
	inline static void Frustum(
		const GLdouble left, 	
		const GLdouble right, 	
		const GLdouble bottom, 	
		const GLdouble top, 	
		const GLdouble znear, 	
		const GLdouble zfar 	
	);
	inline static void Mode( const MMODE mo );
};


class grMatrixf : public grMatrix
{
public:
	GLfloat m[16];

	inline void Load( void ) const;
	inline void Mult( void ) const;
};


class grMatrixd : public grMatrix
{
public:
	GLdouble m[16];

	inline void Load( void ) const;
	inline void Mult( void ) const;
};


	// Class grMatrix

inline void grMatrix::Push( void )
{
	::glPushMatrix();
}


inline void grMatrix::Pop( void )
{
	::glPopMatrix();
}


inline void grMatrix::LoadIdentity( void )
{
	::glLoadIdentity();
}


inline void grMatrix::Frustum(
		const GLdouble left, 	
		const GLdouble right, 	
		const GLdouble bottom, 	
		const GLdouble top, 	
		const GLdouble znear, 	
		const GLdouble zfar 	
	)
{
	glFrustum(left,right,bottom,top,znear,zfar);
}


inline void grMatrix::Mode( const MMODE mo )
{
	glMatrixMode(mo);
}

	// Class grMatrixf

inline void grMatrixf::Load( void ) const
{
	glLoadMatrixf(m);
}


inline void grMatrixf::Mult( void ) const
{
	glMultMatrixf(m);
}

	// Class grMatrixd

inline void grMatrixd::Load( void ) const
{
	glLoadMatrixd(m);
}


inline void grMatrixd::Mult( void ) const
{
	glMultMatrixd(m);
}



#endif
