
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_NORMALBINDING
#define GR_SHQN_NORMALBINDING



#include "node.h"
#include "status.h"


	/** Normals binding.
	    This node specifies the current normalsbinding.
		The values are: PER_VERTEX (a normal for each vertex), OVERALL
		(a normal for all objects), PER_FACE (a normal for
		each face), PER_CORNER (a normal for each vertex in a face),
		PER_PART (a normal for each group of ojects, ie strip, lineset, ...).
		@see grNormal.
	 */
class grNormalBinding : public grNode
{
public:
	enum { PER_VERTEX=0, OVERALL, PER_FACE, PER_CORNER, PER_PART };
		/// Default constructor
	inline grNormalBinding();
		/// see grNode
	const char * Name() const;
	void Render( grStatus & status );
		/// The binding mode.
	int value;

private:
	static const char * name;
};


inline grNormalBinding::grNormalBinding()
{
	value = PER_VERTEX;
}



#endif