
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1   (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_NODE
#define GR_SHQN_NODE


class grStatus;

	/** Abstract base class for all graph nodes.
	    This is the abstract base class from wich all scene node
		classes are derived.
		@see grTree, grRender
	 */
class grNode
{
public:
		/// Return the effective node type name (pure virtual)
	virtual const char * Name() const = 0;
		/// Node traversal for rendering (pure virtual)
	virtual void Render( grStatus & status ) = 0;
		/// Node traversal for selection
	virtual void Select( grStatus & status );
		/** Find node by opengl name.
		    @return This function return this if the node name is name,
			 0 otherwise.
		 */
	virtual grNode * FindByName( const GLuint name );
};


#endif