
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4514 4201 4804 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "texcoord.h"


const char * grTexCoord1d::name ="TexCoord1d";
const char * grTexCoord1f::name ="TexCoord1f";
const char * grTexCoord1i::name ="TexCoord1i";
const char * grTexCoord1s::name ="TexCoord1s";
const char * grTexCoord2d::name ="TexCoord2d";
const char * grTexCoord2f::name ="TexCoord2f";
const char * grTexCoord2i::name ="TexCoord2i";
const char * grTexCoord2s::name ="TexCoord2s";
const char * grTexCoord3d::name ="TexCoord3d";
const char * grTexCoord3f::name ="TexCoord3f";
const char * grTexCoord3i::name ="TexCoord3i";
const char * grTexCoord3s::name ="TexCoord3s";
const char * grTexCoord4d::name ="TexCoord4d";
const char * grTexCoord4f::name ="TexCoord4f";
const char * grTexCoord4i::name ="TexCoord4i";
const char * grTexCoord4s::name ="TexCoord4s";


void grTexCoord::Render( grStatus & status )
{
	status.texcoord = this;
}


const char * grTexCoord1d::Name() const
{
	return name;
}


int grTexCoord1d::Size() const
{
	return vector<double>::size();
}


void grTexCoord1d::GL( const int i ) const
{
	glTexCoord((*this)[i]);
}


const char * grTexCoord1f::Name() const
{
	return name;
}


int grTexCoord1f::Size() const
{
	return vector<float>::size();
}


void grTexCoord1f::GL( const int i ) const
{
	glTexCoord((*this)[i]);
}


const char * grTexCoord1i::Name() const
{
	return name;
}


int grTexCoord1i::Size() const
{
	return vector<int>::size();
}


void grTexCoord1i::GL( const int i ) const
{
	glTexCoord((*this)[i]);
}


const char * grTexCoord1s::Name( void ) const
{
	return name;
}


int grTexCoord1s::Size() const
{
	return vector<short>::size();
}


void grTexCoord1s::GL( const int i ) const
{
	glTexCoord((*this)[i]);
}


const char * grTexCoord2d::Name() const
{
	return name;
}


int grTexCoord2d::Size() const
{
	return vector<Coord2d>::size();
}


void grTexCoord2d::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y);
}


const char * grTexCoord2f::Name() const
{
	return name;
}


int grTexCoord2f::Size() const
{
	return vector<Coord2f>::size();
}


void grTexCoord2f::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y);
}


const char * grTexCoord2i::Name() const
{
	return name;
}


int grTexCoord2i::Size() const
{
	return vector<Coord2i>::size();
}


void grTexCoord2i::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y);
}


const char * grTexCoord2s::Name() const
{
	return name;
}


int grTexCoord2s::Size() const
{
	return vector<Coord2s>::size();
}


void grTexCoord2s::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y);
}


const char * grTexCoord3d::Name() const
{
	return name;
}


int grTexCoord3d::Size() const
{
	return vector<Coord3d>::size();
}


void grTexCoord3d::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grTexCoord3f::Name() const
{
	return name;
}


int grTexCoord3f::Size() const
{
	return vector<Coord3f>::size();
}


void grTexCoord3f::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grTexCoord3i::Name() const
{
	return name;
}


int grTexCoord3i::Size() const
{
	return vector<Coord3i>::size();
}


void grTexCoord3i::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grTexCoord3s::Name() const
{
	return name;
}


int grTexCoord3s::Size() const
{
	return vector<Coord3s>::size();
}


void grTexCoord3s::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grTexCoord4d::Name() const
{
	return name;
}


int grTexCoord4d::Size() const
{
	return vector<Coord4d>::size();
}


void grTexCoord4d::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grTexCoord4f::Name() const
{
	return name;
}


int grTexCoord4f::Size() const
{
	return vector<Coord4f>::size();
}


void grTexCoord4f::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grTexCoord4i::Name() const
{
	return name;
}


int grTexCoord4i::Size() const
{
	return vector<Coord4i>::size();
}


void grTexCoord4i::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grTexCoord4s::Name() const
{
	return name;
}


int grTexCoord4s::Size() const
{
	return vector<Coord4s>::size();
}


void grTexCoord4s::GL( const int i ) const
{
	glTexCoord((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}

