

/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4514 4201 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "transform.h"


const char * grTranslationf::name	= "Tranlationf";
const char * grTranslationd::name	= "Tranlationd";
const char * grRotationf::name		= "Rotationf";
const char * grRotationd::name		= "Rotationd";
const char * grScalef::name			= "Scalef";
const char * grScaled::name			= "Scaled";
const char * grTransformf::name		= "Transformf";
const char * grTransformd::name		= "Transformd";


void grTransform::Render( grStatus & /* status */ )
{
	GL();
}

void grTransform::Select( grStatus & /* status */ )
{
	GL();
}

const char * grTranslationf::Name() const
{
	return name;
}


void grTranslationf::GL() const
{
	glTranslate(x,y,z);
}


const char * grTranslationd::Name() const
{
	return name;
}


void grTranslationd::GL() const
{
	glTranslate(x,y,z);
}


const char * grRotationf::Name() const
{
	return name;
}


void grRotationf::GL() const
{
	glRotate(angle,x,y,z);
}


const char * grRotationd::Name() const
{
	return name;
}


void grRotationd::GL() const
{
	glRotate(angle,x,y,z);
}


const char * grScalef::Name() const
{
	return name;
}


void grScalef::GL( void ) const
{
	glScale(x,y,z);
}


const char * grScaled::Name() const
{
	return name;
}


void grScaled::GL( void ) const
{
	glScale(x,y,z);
}


const char * grTransformf::Name() const
{
	return name;
}


void grTransformf::GL( void ) const
{
	if(mode==MULTIPLY)
		glMultMatrix(m);
	else
		glLoadMatrix(m);
}


const char * grTransformd::Name() const
{
	return name;
}


void grTransformd::GL() const
{
	if(mode==MULTIPLY)
		glMultMatrix(m);
	else
		glLoadMatrix(m);
}

