
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#pragma warning( disable : 4514 4201 4804 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "tree.h"


using namespace std;


const char * grTree::name ="Tree";



const char * grTree::Name() const
{
	return name;
}


void grTree::Render( grStatus & status )
{
	glPushMatrix();
	
	if(list!=-1)
	{
		glCallList(list);
	}
	else
	{
		bufstatus = status;

		for(int i=0;i<int(vector<grNode *>::size());i++)
			(*this)[i]->Render(status);

		status = bufstatus;
	}

	glPopMatrix();
}


void grTree::Select( grStatus & status )
{
	glPushMatrix();
	if(status.onesel==0)
		glPushName(glname);
	
	bufstatus = status;

	for(int i=0;i<int(vector<grNode *>::size());i++)
		(*this)[i]->Select(status);

	status = bufstatus;

	if(status.onesel==0)
		glPopName();
	glPopMatrix();
}


grNode * grTree::FindByName( const GLuint name )
{
	if(name==glname)
		return this;
	else
	{
		for(int i=0;i<int(vector<grNode *>::size());i++)
		{
			grNode * n = (*this)[i]->FindByName(name);
			if(n!=0)
				return n;
		}
		return 0;
	}
}


void grTree::Compile( void )
{
	grStatus s;

	if(list==-1)
	{
		for(list=1;glIsList(list);list++)
			;
	}
	glNewList(list,GL_COMPILE);
		for(int i=0;i<int(vector<grNode *>::size());++i)
			(*this)[i]->Render(s);
	glEndList();
}

