
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V1.0 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/

#pragma warning( disable : 4514 4201 )

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <assert.h>


#include "vertex.h"



const char * grVertex2d::name ="Vertex2d";
const char * grVertex2f::name ="Vertex2f";
const char * grVertex2i::name ="Vertex2i";
const char * grVertex2s::name ="Vertex2s";
const char * grVertex3d::name ="Vertex3d";
const char * grVertex3f::name ="Vertex3f";
const char * grVertex3i::name ="Vertex3i";
const char * grVertex3s::name ="Vertex3s";
const char * grVertex4d::name ="Vertex4d";
const char * grVertex4f::name ="Vertex4f";
const char * grVertex4i::name ="Vertex4i";
const char * grVertex4s::name ="Vertex4s";


void grVertex::Render( grStatus & status )
{
	status.vertex = this;
}


void grVertex::Select( grStatus & status )
{
	status.vertex = this;
}


const char * grVertex2d::Name(  ) const
{
	return name;
}


int grVertex2d::Size(  ) const
{
	return vector<Coord2d>::size();
}


void grVertex2d::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y);
}


const char * grVertex2f::Name(  ) const
{
	return name;
}


int grVertex2f::Size(  ) const
{
	return vector<Coord2f>::size();
}


void grVertex2f::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y);
}


const char * grVertex2i::Name(  ) const
{
	return name;
}


int grVertex2i::Size(  ) const
{
	return vector<Coord2i>::size();
}


void grVertex2i::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y);
}


const char * grVertex2s::Name(  ) const
{
	return name;
}


int grVertex2s::Size(  ) const
{
	return vector<Coord2s>::size();
}


void grVertex2s::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y);
}


const char * grVertex3d::Name(  ) const
{
	return name;
}


int grVertex3d::Size(  ) const
{
	return vector<Coord3d>::size();
}


void grVertex3d::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grVertex3f::Name(  ) const
{
	return name;
}


int grVertex3f::Size(  ) const
{
	return vector<Coord3f>::size();
}


void grVertex3f::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grVertex3i::Name(  ) const
{
	return name;
}


int grVertex3i::Size(  ) const
{
	return vector<Coord3i>::size();
}


void grVertex3i::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grVertex3s::Name(  ) const
{
	return name;
}


int grVertex3s::Size(  ) const
{
	return vector<Coord3s>::size();
}


void grVertex3s::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z);
}


const char * grVertex4d::Name(  ) const
{
	return name;
}


int grVertex4d::Size(  ) const
{
	return vector<Coord4d>::size();
}


void grVertex4d::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grVertex4f::Name(  ) const
{
	return name;
}


int grVertex4f::Size(  ) const
{
	return vector<Coord4f>::size();
}


void grVertex4f::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grVertex4i::Name(  ) const
{
	return name;
}


int grVertex4i::Size(  ) const
{
	return vector<Coord4i>::size();
}


void grVertex4i::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}


const char * grVertex4s::Name(  ) const
{
	return name;
}


int grVertex4s::Size(  ) const
{
	return vector<Coord4s>::size();
}


void grVertex4s::GL( const int i ) const
{
	glVertex((*this)[i].x,(*this)[i].y,(*this)[i].z,(*this)[i].w);
}
