
/*****************************************************************************
 * gcrLib : Graphics Rocchini's Library V0.9 (the nth OpenGL wrapper)        *
 *					                                                         *
 * Copyright(C) 1999 by Claudio Rocchini. All rights reserved.               *
 *					                                                         *
 * Permission  to use, copy, modify, distribute  and sell this  software and *
 * its documentation for any purpose is hereby granted without fee, provided *
 * that  the above copyright notice appear  in all copies and that both that *
 * copyright   notice  and  this  permission  notice  appear  in  supporting *
 * documentation. the author makes  no representations about the suitability *
 * of this software for any purpose. It is provided  "as is" without express *
 * or implied warranty.                                                      *
 *					                                                         *
 *****************************************************************************/


#ifndef GR_SHQN_VIEWER
#define GR_SHQN_VIEWER


class grViewer
{
public:
	grViewer( void );
	void Init( int width, int height );
	void Reset();
	void Resize( int width, int height );
	void StartRotation( int x, int y );
	void EndRotation( int x, int y );
	void StartTranslation( int x, int y );
	void EndTranslation( int x, int y );
	void StartScale( int x, int y );
	void EndScale( int x, int y );
	void End( int x, int y );
	void MouseMove( int x, int y );
	void DoSpinning();

	inline bool IsSpinning() const
	{
		return Spinning!=0 && Mode==NONE;
	}

	float mat[4][4];	// Rotazione
	float scale[3];		// Scala
	float trans[3];		// Traslazione utente (mondo)
	float rtran[3];		// Traslazione del centro di rotazione

private:
	enum VMode { NONE, ROTATION, TRANSLATION, SCALE };

    int		Width;
    int		Height;
	float   lasquat[4];
	float   curquat[4];
	int		MouseDownX;
	int		MouseDownY;
	int		Spinning;
	long    Lastmove;
	VMode   Mode;
};


#endif
